
create table TEST
(
    XX000   INTEGER        NOT null    ,
    XX001   NUMBER(10,3)   null,
    XX002   NUMBER(10,3)   null    ,
    XX003   FLOAT          null,
    XX004   FLOAT          null    ,
    XX005   LONG          null    ,
    XX006   DATE          null    ,
    XX007   DATE          null,
    XX008   CHAR(5)       null,
    XX009   CHAR(5)       null,
  PRIMARY KEY ( XX000 ) 
)
/

create table TEST2
(
    XX000   INTEGER        NOT null    ,
    XX010   long raw   null,
  PRIMARY KEY ( XX000 ) 
)
/

ALTER TABLE TEST2 ADD CONSTRAINT FK_TEST_1
 FOREIGN KEY (XX000)
 REFERENCES TEST (XX000) ON DELETE CASCADE
/


-- INTEGRITY PACKAGE DECLARATION
CREATE OR REPLACE PACKAGE INTEGRITYPACKAGE AS
 PROCEDURE INITNESTLEVEL;
 FUNCTION GETNESTLEVEL RETURN NUMBER;
 PROCEDURE NEXTNESTLEVEL;
 PROCEDURE PREVIOUSNESTLEVEL;
 END INTEGRITYPACKAGE;
/

-- INTEGRITY PACKAGE DEFINITION
CREATE OR REPLACE PACKAGE BODY INTEGRITYPACKAGE AS
 NESTLEVEL NUMBER;

-- PROCEDURE TO INITIALIZE THE TRIGGER NEST LEVEL
 PROCEDURE INITNESTLEVEL IS
 BEGIN
 NESTLEVEL := 0;
 END;


-- FUNCTION TO RETURN THE TRIGGER NEST LEVEL
 FUNCTION GETNESTLEVEL RETURN NUMBER IS
 BEGIN
 IF NESTLEVEL IS NULL THEN
     NESTLEVEL := 0;
 END IF;
 RETURN(NESTLEVEL);
 END;

-- PROCEDURE TO INCREASE THE TRIGGER NEST LEVEL
 PROCEDURE NEXTNESTLEVEL IS
 BEGIN
 IF NESTLEVEL IS NULL THEN
     NESTLEVEL := 0;
 END IF;
 NESTLEVEL := NESTLEVEL + 1;
 END;

-- PROCEDURE TO DECREASE THE TRIGGER NEST LEVEL
 PROCEDURE PREVIOUSNESTLEVEL IS
 BEGIN
 NESTLEVEL := NESTLEVEL - 1;
 END;

 END INTEGRITYPACKAGE;
/



CREATE OR REPLACE TRIGGER TEST_UPD_TS BEFORE INSERT OR UPDATE
ON TEST FOR EACH ROW
DECLARE
    INTEGRITY_ERROR  EXCEPTION;
    ERRNO            INTEGER;
    ERRMSG           CHAR(200);
    DUMMY            INTEGER;
    FOUND            BOOLEAN;
    CARDINALITY      INTEGER;
BEGIN
    INTEGRITYPACKAGE.NEXTNESTLEVEL;

    :NEW.XX007 := SYSDATE;

    INTEGRITYPACKAGE.PREVIOUSNESTLEVEL;

--  ERRORS HANDLING
EXCEPTION
    WHEN INTEGRITY_ERROR THEN
       BEGIN
       INTEGRITYPACKAGE.INITNESTLEVEL;
       RAISE_APPLICATION_ERROR(ERRNO, ERRMSG);
       END;
END;
/


CREATE OR REPLACE VIEW TESTX (XX000,
XX001,XX002,XX003,XX004,XX005,XX006,XX007,XX010) AS 
SELECT TEST.XX000,TEST.XX001,TEST.XX002,TEST.XX003,TEST.XX004,TEST.XX005,TEST.XX006,TEST.XX007,TEST2.XX010
       FROM TEST, TEST2
       WHERE TEST.XX000 = TEST2.XX000(+)
/


CREATE OR REPLACE VIEW TESTXRO (XX000,
XX001,XX002,XX003,XX004,XX005,XX006,XX007,XX010) AS 
SELECT TEST.XX000,TEST.XX001,TEST.XX002,TEST.XX003,TEST.XX004,TEST.XX005,TEST.XX006,TEST.XX007,TEST2.XX010
       FROM TEST, TEST2
       WHERE TEST.XX000 = TEST2.XX000(+)
WITH READ ONLY
/


CREATE SEQUENCE test_id INCREMENT BY 1  START WITH -2000000000 MINVALUE -2000000000
/


create or replace trigger test_bfi before insert on test
for each row
DECLARE
nKey NUMBER;
begin
-- Pokud je poteba generovat id jen pokud nen definovno
IF :NEW.XX000 IS NULL THEN 
   SELECT test_id.NEXTVAL INTO nKey FROM dual;
   :NEW.XX000 := nKey;
END IF;
end;
/


INSERT INTO TEST (XX000,XX001,XX002,XX003,XX004)
      VALUES
      (test_id.nextval,2.521,2.521,3.512,3.512)
/

INSERT INTO TEST (XX001,XX002,XX003,XX004,XX005)
      VALUES
      (1.888,1.888,3.444,3.333,'aaaaaaaaaaaaaaa-ssssssssss-ssssssssss')
/

INSERT INTO TEST (XX001,XX002,XX003,XX004,XX008,XX009)
      VALUES
      (1.888,1.888,3.444,3.333,'AA','BB')
/

INSERT INTO TEST (XX001,XX002,XX003,XX004,XX008,XX009)
      VALUES
      (1.888,1.888,3.444,3.333,'AB','BA')
/

INSERT INTO TEST (XX001,XX002,XX003,XX004,XX008,XX009)
      VALUES
      (1.888,1.888,3.444,3.333,'BA','BA')
/

INSERT INTO TEST (XX001,XX002,XX003,XX004,XX008,XX009)
      VALUES
      (1.888,1.888,3.444,3.333,'BB','AB')
/

INSERT INTO TEST (XX001,XX002,XX003,XX004,XX008,XX009)
      VALUES
      (1.888,1.888,3.444,3.333,'AA','')
/

INSERT INTO TEST (XX001,XX002,XX003,XX004,XX008,XX009)
      VALUES
      (1.888,1.888,3.444,3.333,'','BB')

/
commit
/



-- Stored procedure
CREATE OR REPLACE PACKAGE Foxpackage AS
TYPE YY000 IS TABLE OF  NUMBER(5)
 INDEX BY BINARY_INTEGER;
TYPE YY001 IS TABLE OF VARCHAR2(10)
  INDEX BY BINARY_INTEGER;
TYPE YY002 IS TABLE OF VARCHAR2(5)
 INDEX BY BINARY_INTEGER;
TYPE XX000 IS TABLE OF INTEGER
  INDEX BY BINARY_INTEGER;
TYPE XX001 IS TABLE OF NUMBER(11,3)
 INDEX BY BINARY_INTEGER;
TYPE t_cursor IS REF CURSOR ;

 PROCEDURE GetList
  (
    pnYY000  OUT  YY000,
    pcYY001  OUT  YY001,
    pcYY002  OUT  YY002
 );

 PROCEDURE GetResult
 (
  pipXX000  IN   INTEGER,
  piXX000   OUT  XX000,
  pnXX001   OUT  XX001
 );

 PROCEDURE GetRecordsCount
 (
  pipXX000  IN   INTEGER,
  piXX000   OUT  XX000
 );

  PROCEDURE GetResultX
 (
  pipXX000  IN   INTEGER,
  pnpXX000  IN   INTEGER,
  piXX000   OUT  XX000,
  pnXX001   OUT  XX001
 );

PROCEDURE GetResultY(
  pipXX000  IN   INTEGER,
  io_cursor IN OUT t_cursor
  ); 

 
 PROCEDURE Recalc
 (
  piiZZ000  IN   INTEGER,
  piiZZ001  IN   INTEGER,
  poiZZ002  OUT  INTEGER
 );

  FUNCTION func3
 (
  piiZZ000  IN   INTEGER,
  piiZZ001  IN   INTEGER
  
 ) RETURN INTEGER;
 
 PROCEDURE UpdateTable
 (
  piiZZ000  IN   INTEGER,
  picZZ008  IN   CHAR
 );

  END Foxpackage;
/

CREATE OR REPLACE PACKAGE BODY Foxpackage AS
 PROCEDURE  GetList
  (
   pnYY000     OUT  YY000,
   pcYY001     OUT  YY001,
   pcYY002     OUT  YY002
  )
  AS
   BEGIN
    pnYY000(1) := 200;
    pcYY001(1) :=  'M101';
    pcYY002(1) :=  'EEE' ;
    pnYY000(2) := 201;
    pcYY001(2) :=  'PHY320';
    pcYY002(2) :=  'ECE' ;
END GetList;


PROCEDURE GetResult
 (
   pipXX000       IN   INTEGER,
   piXX000        OUT  XX000,
   pnXX001        OUT  XX001
 )
  AS
  CURSOR XXC000 IS
	SELECT XX000,XX001
	FROM TEST
        WHERE XX000 > pipXX000;

   i  NUMBER;
 BEGIN
  i:=0;
  FOR loRam IN XXC000 LOOP
      i:=i+1;
      piXX000(i) := loRam.XX000;
      pnXX001(i) := loRam.XX001;
  END LOOP;
 END GetResult;

PROCEDURE GetRecordsCount
 (
   pipXX000       IN   INTEGER,
   piXX000        OUT  XX000
 )
  AS
 BEGIN
 SELECT COUNT(XX000)  INTO piXX000(1) FROM TEST
        WHERE XX000 > pipXX000;
		
	
 END GetRecordsCount;


PROCEDURE GetResultX
 (
   pipXX000       IN   INTEGER,
   pnpXX000       IN   INTEGER,
   piXX000        OUT  XX000,
   pnXX001        OUT  XX001
 )
  AS
  CURSOR XXC000 IS
	SELECT XX000,XX001
	FROM TEST
        WHERE XX000 > pipXX000;

   i  NUMBER;
 BEGIN
  i:=0;
  FOR loRam IN XXC000 LOOP
      i:=i+1;
	  IF i> pnpXX000 THEN
	     EXIT; 
	  END IF;
      piXX000(i) := loRam.XX000;
      pnXX001(i) := loRam.XX001;
  END LOOP;
 END GetResultX;

 
PROCEDURE GetResultY (
   pipXX000  IN   INTEGER,
   io_cursor IN OUT t_cursor) 
IS 
   v_cursor t_cursor; 
BEGIN 
   OPEN v_cursor FOR 
	SELECT XX000,XX001
	FROM TEST
        WHERE XX000 > pipXX000;
	io_cursor := v_cursor; 
END GetResultY;
 
 
PROCEDURE Recalc
 (
  piiZZ000  IN   INTEGER,
  piiZZ001  IN   INTEGER,
  poiZZ002  OUT  INTEGER
  
 )
 IS
 BEGIN

  poiZZ002:=piiZZ000+piiZZ001;
  
 END Recalc;
 
 
FUNCTION func3
 (
  piiZZ000  IN   INTEGER,
  piiZZ001  IN   INTEGER
  ) RETURN INTEGER
 IS
 BEGIN
 
  RETURN piiZZ000+piiZZ001;
 END func3;

 PROCEDURE UpdateTable
 (
  piiZZ000  IN   INTEGER,
  picZZ008  IN   CHAR
 )
 IS
 BEGIN

  UPDATE TEST SET XX008=picZZ008  WHERE XX000=piiZZ000;
  COMMIT;
 END UpdateTable;

 
END Foxpackage;
/



--  *********************************************************************
--  RI TEST
--     TEST2
--  *********************************************************************


--  AFTER UPDATE TRIGGER "TEST_TUA" FOR TABLE "TEST"
CREATE OR REPLACE  TRIGGER TEST_TUA AFTER UPDATE
OF XX000
ON TEST FOR EACH ROW
DECLARE
    INTEGRITY_ERROR  EXCEPTION;
    ERRNO            INTEGER;
    ERRMSG           CHAR(200);
    DUMMY            INTEGER;
    FOUND            BOOLEAN;
    CARDINALITY      INTEGER;
BEGIN
    INTEGRITYPACKAGE.NEXTNESTLEVEL;
    
    --  MODIFY PARENT CODE OF "TEST" FOR ALL CHILDREN IN "TEST2"
    IF (UPDATING('XX000') AND :OLD.XX000 != :NEW.XX000) THEN
       UPDATE TEST2
        SET   XX000 = :NEW.XX000
       WHERE  XX000 = :OLD.XX000;
    END IF;
    
    INTEGRITYPACKAGE.PREVIOUSNESTLEVEL;

--  ERRORS HANDLING
EXCEPTION
    WHEN INTEGRITY_ERROR THEN
       BEGIN
       INTEGRITYPACKAGE.INITNESTLEVEL;
       RAISE_APPLICATION_ERROR(ERRNO, ERRMSG);
       END;
END;
/


--  AFTER DELETE TRIGGER "TEST_TDA" FOR TABLE "TEST"
CREATE OR REPLACE  TRIGGER TEST_TDA AFTER DELETE
ON TEST FOR EACH ROW
DECLARE
    INTEGRITY_ERROR  EXCEPTION;
    ERRNO            INTEGER;
    ERRMSG           CHAR(200);
    DUMMY            INTEGER;
    FOUND            BOOLEAN;

BEGIN
    INTEGRITYPACKAGE.NEXTNESTLEVEL;
    
    --  DELETE ALL CHILDREN IN "TEST2"
    DELETE TEST2 WHERE  XX000 = :OLD.XX000;

    INTEGRITYPACKAGE.PREVIOUSNESTLEVEL;

--  ERRORS HANDLING
EXCEPTION
    WHEN INTEGRITY_ERROR THEN
       BEGIN
       INTEGRITYPACKAGE.INITNESTLEVEL;
       RAISE_APPLICATION_ERROR(ERRNO, ERRMSG);
       END;
END;
/




--  BEFORE INSERT TRIGGER "TEST2_TIB" FOR TABLE "TEST2"
CREATE OR REPLACE  TRIGGER TEST2_TIB BEFORE INSERT OR UPDATE
ON TEST2 FOR EACH ROW
DECLARE
    INTEGRITY_ERROR  EXCEPTION;
    ERRNO            INTEGER;
    ERRMSG           CHAR(200);
    DUMMY            INTEGER;
    FOUND            BOOLEAN;
    CARDINALITY      INTEGER;
    
    --  DECLARATION OF INSERTCHILDPARENTEXIST CONSTRAINT FOR THE PARENT "TEST"
    CURSOR CPK1_TEST(VAR_XX000 INTEGER) IS
       SELECT 1
       FROM   TEST
       WHERE  XX000 = VAR_XX000
        AND   VAR_XX000 IS NOT NULL;

BEGIN
    --  PARENT "TEST2" MUST EXIST WHEN INSERTING A CHILD IN "TEST2"
    IF :NEW.XX000 IS NOT NULL THEN
       OPEN  CPK1_TEST(:NEW.XX000);
       FETCH CPK1_TEST INTO DUMMY;
       FOUND := CPK1_TEST%FOUND;
       CLOSE CPK1_TEST;
       IF NOT FOUND THEN
          ERRNO  := -20002;
          ERRMSG := 'Parent does not exist in "TEST". Cannot CREATE OR REPLACE  child in "TEST2".';
          RAISE INTEGRITY_ERROR;
       END IF;
    END IF;

--  ERRORS HANDLING
EXCEPTION
    WHEN INTEGRITY_ERROR THEN
       RAISE_APPLICATION_ERROR(ERRNO, ERRMSG);
END;
/
